chiark / gitweb /
xinitrc, setup: Overhaul of X session handling.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 umask 002
6
7 sub=
8 mkdir -p $HOME$sub
9
10 : ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
11
12 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
13
14 ### Sort out command line
15 xstuff= false=
16 while [ $# -gt 0 ]; do
17   case "$1" in
18     -x) xstuff=t;;
19     -n) false=false;;
20     --) shift; break;;
21     -*) echo >&2 "$0: bad option"; exit 1;;
22     *) break;;
23   esac
24   shift
25 done
26
27 ### Find out where I am
28 here=$(pwd)
29
30 ### Suss out how to print things
31 out=$(echo -n "foo"; echo "bar")
32 if [ "$out" = "foobar" ]; then
33   echon="echo -n"
34   echoc=""
35 else
36   echon="echo"
37   echoc='\c'
38 fi
39
40 ### Create the necessary directories
41 echo "Creating directories..."
42 for i in bin lib/emacs src; do
43   $echon "  $i:$echoc"
44   if [ -d $HOME$sub/$i ]; then
45     echo " already exists."
46   else
47     mkdir -p $HOME$sub/$i
48     echo " done."
49   fi
50 done
51 echo "  all done."
52
53 ### Find out how to fetch things over the net
54 $echon "Finding URL fetcher:$echoc"
55 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
56   GETURL="curl -fs -o"
57   echo " curl."
58 elif wget >/dev/null 2>&1 --version; then
59   GETURL="wget -q -O"
60   echo " wget."
61 else
62   echo " failed!"
63   echo >&2 "$0: failed to find URL fetcher"
64   exit 1
65 fi
66
67 ### Install necessary things
68 echo "Installing useful scripts..."
69
70 scripts="
71   lesspipe.sh start-ssh-agent svnwrap"
72 for script in $scripts; do
73   $echon "  $script:$echoc"
74   found=
75   for p in /bin /usr/bin /usr/local/bin $(echo $PATH | tr : ' '); do
76     if $false [ -x $p/$script ]; then
77       found=t
78       break
79     fi
80   done
81   if [ "$found" ]; then
82     echo " already installed."
83   else
84     $echon " downloading$echoc"
85     $GETURL $HOME$sub/bin/$script $REPO/$script
86     chmod +x $HOME$sub/bin/$script
87     echo " done."
88   fi
89 done
90
91 echo "  all done."
92
93 ### Install some more complicated programs
94 echo "Installing packages..."
95 systems="
96   mlib:2.0.4:crc-mktab
97   chkpath:1.1.0:tmpdir
98 "
99 [ "$xstuff" ] && systems="$systems
100   xtoys:1.4.0:xatom
101 "
102 for system in $systems; do
103   set -- $(echo $system | tr : ' ')
104   sys=$1 ver=$2 prog=$3
105   $echon "  $sys:$echoc"
106   if $false $prog >/dev/null 2>&1 --version; then
107     echo " already installed."
108   else
109     ( set -e
110       $echon " downloading$echoc"
111       cd $HOME$sub/src
112       rm -rf $sys-$ver.tar.gz $sys-$ver
113       $GETURL $sys-$ver.tar.gz $REPO/$sys-$ver.tar.gz
114       $echon " unpacking$echoc"
115       gzip -cd $sys-$ver.tar.gz | tar xf -
116       $echon " configuring$echoc"
117       cd $sys-$ver
118       mkdir build
119       cd build
120       ../configure --prefix=$HOME$sub >>buildlog 2>&1
121       $echon " building$echoc"
122       make >>buildlog 2>&1
123       $echon " installing$echoc"
124       make install >>buildlog 2>&1
125       echo " done."
126     )
127   fi
128 done
129 echo "  all done."
130
131 ### Install global configuration
132 echo -n "Installing dotfile configuration:"
133 if [ -f $HOME$sub/.mdw.conf ]; then
134   echo " already installed."
135 else
136   cp mdw.conf $HOME$sub/.mdw.conf
137   echo " done."
138 fi
139
140 ### Symlink the various dotfiles into place
141 dotfiles="
142   bash_profile bash_logout bashrc inputrc bash_completion
143   emacs emacs-calc vm
144   vimrc mg
145   mailrc signature
146   gitconfig cgrc tigrc
147   gdbinit
148   guile
149   lisp-init.lisp:.cmucl-init.lisp
150     lisp-init.lisp:.sbclrc
151     lisp-init.lisp:.clisprc.lisp
152     lisp-init.lisp:.eclrc
153   dircolors colordiffrc screenrc cvsrc indent.pro"
154 [ "$xstuff" ] && dotfiles="$dotfiles
155   xinitrc xsession Xdefaults vncrc vncsession
156   putty-defaults:.putty/sessions/Default%20Settings
157   e-keybindings.cfg:.enlightenment/keybindings.cfg
158   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
159   e16-bindings:.e16/bindings.cfg
160   e16-config:.e16/e_config--1.0.cfg
161   jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg
162   jue-peek.jpg:.e16/backgrounds/jue-peek.jpg"
163 echo "Installing dotfiles..."
164 for d in $dotfiles; do
165   target=.$d
166   case $d in
167     *:*) target=${d#*:} d=${d%%:*};;
168   esac
169   ft=$HOME$sub/$target
170   dir=${ft%/*}
171   mkdir -p $dir
172   ln -s $here/$d $ft.new
173   mv $ft.new $ft
174   echo "  $target"
175 done
176 echo "  all done."
177
178 ### Install useful scripts included in this package
179 scripts="
180   mdw-editor
181   movemail-hack
182   emerge-hack"
183 [ "$xstuff" ] && scripts="$scripts
184   xrun
185   xshutdown"
186 echo "Installing scripts..."
187 mkdir -p $HOME$sub/bin
188 for s in $scripts; do
189   ft=$HOME$sub/bin/$s
190   ln -s $here/$s $ft.new
191   mv $ft.new $ft
192   echo "  $s"
193 done
194 echo "  all done."
195
196 ### Set up the Emacs config
197 $echon "Finding a suitable emacs:$echoc"
198 emacs=no
199 for i in emacs22 emacs21 emacs; do
200   if type -p >/dev/null $i; then
201     emacs=$i
202     break
203   fi
204 done
205 if [ $emacs = no ]; then
206   echo " failed."
207   emacs=:
208 else
209   echo " $emacs."
210 fi
211
212 echo "Installing Emacs packages..."
213 emacspkg="
214   make-regexp
215   git git-blame vc-git stgit
216   quilt"
217 for elib in $emacspkg; do
218   $echon "  $elib:$echoc"
219   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
220        (progn
221          (setq load-path (nconc load-path (list "~/lib/emacs")))
222          (kill-emacs (condition-case nil
223                          (progn (load-library "'"$elib"'") 0)
224                        (error 1))))'; then
225     echo " already installed."
226   else
227     $echon " downloading$echoc"
228     $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
229     $echon " compiling$echoc"
230     (cd $HOME$sub/lib/emacs;
231       $emacs >/dev/null 2>&1 --no-site-file --batch \
232         --eval '(byte-compile-file "'"$elib.el"'")')
233     echo " done."
234   fi
235 done
236 echo "  all done."
237
238 $echon "Setting up Emacs configuration:$echoc"
239 $echon " linking$echoc"
240 for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
241   set -- $(echo $link | tr : ' ')
242   from=$1 to=$2
243   ln -s $here/$from $HOME$sub/lib/emacs/$to.new
244   mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
245 done
246 $echon " compiling$echoc"
247 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
248 echo " done."